
# todo

Transitioning to Sway/Wayland for desktop environment.

_Expect iterative changes over the following months while fine-tuning happens on real hardware._


## sway

Going directly to hardware trials because virtualbox support requires too much undesirable configuration:


---

Consider modifying this line to stop the sway-session.target:

	bindsym $mod+x exec swaymsg exit

Like:

	bindsym $mod+x exec "systemctl --user import-environment; systemctl --user stop sway-session.target; swaymsg exit"


---

When I eventually break down and buy elden ring, try these?

	PROTON_NO_FSYNC=1 WINE_FULLSCREEN_FSR=1 mangohud gamemoderun %command%

May need other steps for ultrawide support?

https://github.com/gurrgur/er-patcher

	./er-patcher -r 144 -uavc -- env <above command>


---

- move aur packages to install under the actual user and download to their src directory (for easier updates)
- add these packages to the installation list:
	- xpadneo-dkms
	- cmst (sway/wayland friendly connman management)
	- corectrl
		- add `.service` to userspace systemd
	- wev (_need to verify necessity?_)
	- https://aur.archlinux.org/packages/mpv-mpris/
- Change aur packages to install under the user being created instead of a temporary user
	- _this will allow that user to find and update them more readily/easily_


- investigate `poweralertd` and `batsignal` to setup low battery alerts with `mako`


- create alacritty config copying from former xdefaults
	- https://sunnnychan.github.io/cheatsheet/linux/config/alacritty.yml.html
	- _transparency is a great start, but we're not done!_


---

- continue to refine `notes/sway.md` to account for the lack of obvious world-knowledge

- Test SteamVR
	- Setup two new base stations for 4-station setup
	- Reconfigure steam vr utils software
		- Make sure all 4 base stations connect
		- Make sure all 4 base stations shutdown
		- Make sure audio transitions to and from
	- try Beat Saber
	- try No Man's Sky


---

- write a script to grab temperatures to replace the temperature module in waybar with custom commands...
	- _this is because configuring temperatures is hardware dependent and the waybar has unintelligent defaults and anti-agnostic configuration!_

Example that matters?

for amd cpu: `k10temp` followed by `tctl`
for intel cpu: `coretemp` followed by `package id 0`
for amd gpu `amdgpu` followed by `edge`

for nvidia we need to use `nvidia-smi` and parse that instead, but that also means if `nvidia-smi` does not exist we have to back out!

_For this we will want to have an `exec-if` that checks for results
_There may be cases where there is no GPU, so when no sensors appear can we have the custom module omitted?_

For gpu temperatures:

- `amdgpu`, followed by `edge`

_This may not exist for laptops, may differ for nvidia, and may also differ depending on the driver._

Samples:

	"custom/cputemp": {
		"format": "{}°C",
		"interval": "3",
		"exec": "/usr/local/bin/temps cpu",
		"exec-if": "/usr/local/bin/temps cpu can"
	}
	"custom/gputemp": {
		"format": "GPU: {}°C",
		"interval": "3",
		"exec": "/usr/local/bin/temps gpu",
		"exec-if": "/usr/local/bin/temps gpu can"
	}


---

- test writing a script to iterate scratchpad items
	- need to be able to get a list
	- need that list to be reliably ordered
		- _or need to impose an order_
	- can potentially replace `scratchpad show` with `exec`

New `/usr/local/bin/alacrittyq` with `$mod+tilde` toggle:

	#!/bin/bash

	# @todo: query swaymsg get_tree for alacrittyq
	# if not exists launch
	# if exists
	# if hidden in scratchpad show
	# if shown hide in scratchpad
	alacritty --class "alacrittyq"

- investigate dedicated identity for an alacritty window to selectively target for scratchpad persistent terminal via mod+tilde


---

- It may be possible to write an IPC connected utility to save and restore workspaces
	- _this tool would need to know when to save, and to intelligently restore only once when applications are first launched._
	- It would need to have a way to pull wayland equivalents for the content mentioned in this issue:
		- https://github.com/swaywm/sway/issues/1005


---

- test hidpi configuration
	- `output * scale 2`
	- also targeted output scaling for HDTV but not ultrawide
- Verify hidpi behavior of applications is not poor:
	- firefox (many different websites?)
	- mpv
	- pcmanfm
	- steam
	- discord
- _Remember to take some screenshots before and after to indicate visible changes?_


---

- investigate firefox configuration
	- [auto-configuration?](https://support.mozilla.org/en-US/kb/customizing-firefox-using-autoconfig)
	- add mimetypes to bypass godawful save dialog (eg. hanlders.json in `~/.mozilla`, but unique profile path?)
	- how to make it remember workspaces when restoring tabs (_probably not possible, so using tab manager addon_)


---

- utilize my old rig to cleanup and organize my data across my old HDD's
	- _transfer `views/` ASAP..._
	- uninstall all games and other content taking up space
	- disable transmission so I can avoid accidentally increasing the files on this disk
	- this includes sorting what is on `data/`, the other 2TB disk
